# THIS IS THE FILE THAT IS CALLED TO RUN THE ANALYSIS THAT GENERATES ALL RESULTS FROM MAGGIORI, NEIMAN, AND SCHREGER, "INTERNATIONAL CURRENCIES AND CAPITAL ALLOCATION", JOURNAL OF POLITICAL ECONOMY, ACCEPTED FOR PUBLICATION, 2019
# IT REQUIRES INPUT FILES THAT ARE GENERATED BY RUNNING Master_Build.sh. 
# PLEASE SEE ReadMe_Analysis.txt FOR DETAILS. 

#!/bin/bash
echo "Begin Master Analysis for MNS Project ..."

# INPUTS COMMON ACROSS ALL ANALYSIS STEPS

nodes=1
mailtype="FAIL"
mns_data_path="path to mns_data"
mns_code_path="path to mns_code"
mns_erroroutput_path="${mns_data_path}/results/temp/erroroutput"
mkdir -p "${mns_erroroutput_path}"
mailuser="email address"

# INPUTS THAT VARY ACROSS ANALYSIS STEPS

partition_Fund_Bias_Step1="partition name"
time_Fund_Bias_Step1="0-12:00:00"
ntasks_Fund_Bias_Step1=12
mem_Fund_Bias_Step1="250000"

partition_Fund_Bias_Step2="partition name"
time_Fund_Bias_Step2="0-12:00:00"
ntasks_Fund_Bias_Step2=12
mem_Fund_Bias_Step2="250000"

partition_Fund_Bias_Step3="partition name"
time_Fund_Bias_Step3="0-12:00:00"
ntasks_Fund_Bias_Step3=12
mem_Fund_Bias_Step3="250000"

partition_Gen_HD_Sumstats_Step1="partition name"
time_Gen_HD_Sumstats_Step1="0-12:00:00"
ntasks_Gen_HD_Sumstats_Step1=12
mem_Gen_HD_Sumstats_Step1="250000"

partition_Gen_HD_Sumstats_Step2="partition name"
time_Gen_HD_Sumstats_Step2="0-12:00:00"
ntasks_Gen_HD_Sumstats_Step2=12
mem_Gen_HD_Sumstats_Step2="250000"

partition_Gen_Portfolio_Sumstat_Step1="partition name"
time_Gen_Portfolio_Sumstat_Step1="0-12:00:00"
ntasks_Gen_Portfolio_Sumstat_Step1=12
mem_Gen_Portfolio_Sumstat_Step1="250000"

partition_Gen_Portfolio_Sumstat_Step2="partition name"
time_Gen_Portfolio_Sumstat_Step2="0-12:00:00"
ntasks_Gen_Portfolio_Sumstat_Step2=12
mem_Gen_Portfolio_Sumstat_Step2="250000"

partition_Data_Comparison_Plots="partition name"
time_Data_Comparison_Plots="0-04:00:00"
ntasks_Data_Comparison_Plots=8
mem_Data_Comparison_Plots="100000"

partition_CurrencyShare_TimeSeries="partition name"
time_CurrencyShare_TimeSeries="0-04:00:00"
ntasks_CurrencyShare_TimeSeries=4
mem_CurrencyShare_TimeSeries="62000"

partition_CurrencyShare_BarCharts="partition name"
time_CurrencyShare_BarCharts="0-04:00:00"
ntasks_CurrencyShare_BarCharts=4
mem_CurrencyShare_BarCharts="62000"

partition_Probits="partition name"
time_Probits="0-04:00:00"
ntasks_Probits=8
mem_Probits="150000"

partition_Portfolio_Conc_and_Dist="partition name"
time_Portfolio_Conc_and_Dist="0-08:00:00"
ntasks_Portfolio_Conc_and_Dist=4
mem_Portfolio_Conc_and_Dist="62000"

partition_Regressions="partition name"
time_Regressions="0-05:00:00"
ntasks_Regressions=4
mem_Regressions="250000"

partition_Debt_Equity_Plots="partition name"
time_Debt_Equity_Plots="0-05:00:00"
ntasks_Debt_Equity_Plots=2
mem_Debt_Equity_Plots="100000"          


# BELOW SEQUENCES PASS ANALYSIS STEP AS ARGUMENT TO Master_Analysis_Controller.sh
# THOSE SEQUENCES WITH AN "array=" LINE ARE RUNNING CODE IN PARALLEL AS AN ARRAY JOB
# THOSE SEQUENCES WITH AN "depend=afterok:" ARE ONLY RUNNING AFTER EARLIER STEPS ARE SUCCESSFULLY COMPLETED
# FOR DETAILS ON WHAT EACH STEP DOES, SEE COMMENTS IN Master_Analysis.do, WHICH IS CALLED BY Master_Analysis_Controller.sh AND RUNS EACH STEP

# Fund_Bias, Step 1
array_Fund_Bias_Step1="1-33"
JOB_Fund_Bias_Step1_ID=`sbatch \
         --partition=${partition_Fund_Bias_Step1} --time=${time_Fund_Bias_Step1} \
         --nodes=${nodes} --ntasks=${ntasks_Fund_Bias_Step1} --job-name=Fund_Bias_Step1 \
         --array=${array_Fund_Bias_Step1} --output="${mns_erroroutput_path}/Fund_Bias_Step1-%A_%a.out" \
         --error="${mns_erroroutput_path}/Fund_Bias_Step1-%A_%a.err" \
         --mail-user=${mailuser} --mail-type=${mailtype} --requeue --mem=${mem_Fund_Bias_Step1} \
           "${mns_code_path}/analysis/Master_Analysis_Controller.sh" Fund_Bias_Step1 | awk '{print $NF}'`
echo "Submitted Fund_Bias_Step1 Job: "${JOB_Fund_Bias_Step1_ID}
sleep 1

# Fund_Bias, Step 2
JOB_Fund_Bias_Step2_ID=`sbatch \
         --partition=${partition_Fund_Bias_Step2} --time=${time_Fund_Bias_Step2} \
         --nodes=${nodes} --ntasks=${ntasks_Fund_Bias_Step2} --job-name=Fund_Bias_Step2 \
         --depend=afterok:${JOB_Fund_Bias_Step1_ID} \
         --array=${array_Fund_Bias_Step2} --output="${mns_erroroutput_path}/Fund_Bias_Step2-%A_%a.out" \
         --error="${mns_erroroutput_path}/Fund_Bias_Step2-%A_%a.err" \
         --mail-user=${mailuser} --mail-type=${mailtype} --requeue --mem=${mem_Fund_Bias_Step2} \
           "${mns_code_path}/analysis/Master_Analysis_Controller.sh" Fund_Bias_Step2 | awk '{print $NF}'`
echo "Submitted Fund_Bias_Step2 Job: "${JOB_Fund_Bias_Step2_ID}
sleep 1

# Fund_Bias, Step 3
array_Fund_Bias_Step3="1-2"
JOB_Fund_Bias_Step3_ID=`sbatch \
         --partition=${partition_Fund_Bias_Step3} --time=${time_Fund_Bias_Step3} \
         --nodes=${nodes} --ntasks=${ntasks_Fund_Bias_Step3} --job-name=Fund_Bias_Step3 \
         --depend=afterok:${JOB_Fund_Bias_Step2_ID} \
         --array=${array_Fund_Bias_Step3} --output="${mns_erroroutput_path}/Fund_Bias_Step3-%A_%a.out" \
         --error="${mns_erroroutput_path}/Fund_Bias_Step3-%A_%a.err" \
         --mail-user=${mailuser} --mail-type=${mailtype} --requeue --mem=${mem_Fund_Bias_Step3} \
           "${mns_code_path}/analysis/Master_Analysis_Controller.sh" Fund_Bias_Step3 | awk '{print $NF}'`
echo "Submitted Fund_Bias_Step3 Job: "${JOB_Fund_Bias_Step3_ID}
sleep 1

# Gen_HD_Sumstats, Step 1
array_Gen_HD_Sumstats_Step1="1"
JOB_Gen_HD_Sumstats_Step1_ID=`sbatch \
         --partition=${partition_Gen_HD_Sumstats_Step1} --time=${time_Gen_HD_Sumstats_Step1} \
         --nodes=${nodes} --ntasks=${ntasks_Gen_HD_Sumstats_Step1} --job-name=Gen_HD_Sumstats_Step1 \
         --depend=afterok:${JOB_Pre_Analysis_ID} \
         --array=${array_Gen_HD_Sumstats_Step1} --output="${mns_erroroutput_path}/Gen_HD_Sumstats_Step1-%A_%a.out" \
         --error="${mns_erroroutput_path}/Gen_HD_Sumstats_Step1-%A_%a.err" \
         --mail-user=${mailuser} --mail-type=${mailtype} --requeue --mem=${mem_Gen_HD_Sumstats_Step1} \
           "${mns_code_path}/analysis/Master_Analysis_Controller.sh" Gen_HD_Sumstats | awk '{print $NF}'`
echo "Submitted Gen_HD_Sumstats_Step1 Job: "${JOB_Gen_HD_Sumstats_Step1_ID}
sleep 1

# Gen_HD_Sumstats, Step 2
array_Gen_HD_Sumstats_Step2="2-3"
JOB_Gen_HD_Sumstats_Step2_ID=`sbatch \
         --partition=${partition_Gen_HD_Sumstats_Step2} --time=${time_Gen_HD_Sumstats_Step2} \
         --nodes=${nodes} --ntasks=${ntasks_Gen_HD_Sumstats_Step2} --job-name=Gen_HD_Sumstats_Step2 \
         --depend=afterok:${JOB_Gen_HD_Sumstats_Step1_ID} \
         --array=${array_Gen_HD_Sumstats_Step2} --output="${mns_erroroutput_path}/Gen_HD_Sumstats_Step2-%A_%a.out" \
         --error="${mns_erroroutput_path}/Gen_HD_Sumstats_Step2-%A_%a.err" \
         --mail-user=${mailuser} --mail-type=${mailtype} --requeue --mem=${mem_Gen_HD_Sumstats_Step2} \
           "${mns_code_path}/analysis/Master_Analysis_Controller.sh" Gen_HD_Sumstats | awk '{print $NF}'`
echo "Submitted Gen_HD_Sumstats_Step2 Job: "${JOB_Gen_HD_Sumstats_Step2_ID}
sleep 1

# Gen_Portfolio_Sumstat, Step 1
array_Gen_Portfolio_Sumstat_Step1="1-32"
JOB_Gen_Portfolio_Sumstat_Step1_ID=`sbatch \
         --partition=${partition_Gen_Portfolio_Sumstat_Step1} --time=${time_Gen_Portfolio_Sumstat_Step1} \
         --nodes=${nodes} --ntasks=${ntasks_Gen_Portfolio_Sumstat_Step1} --job-name=Gen_Portfolio_Sumstat_Step1 \
         --depend=afterok:${JOB_Pre_Analysis_ID} \
         --array=${array_Gen_Portfolio_Sumstat_Step1} --output="${mns_erroroutput_path}/Gen_Portfolio_Sumstat_Step1-%A_%a.out" \
         --error="${mns_erroroutput_path}/Gen_Portfolio_Sumstat_Step1-%A_%a.err" \
         --mail-user=${mailuser} --mail-type=${mailtype} --requeue --mem=${mem_Gen_Portfolio_Sumstat_Step1} \
           "${mns_code_path}/analysis/Master_Analysis_Controller.sh" Gen_Portfolio_Sumstat_Step1 | awk '{print $NF}'`
echo "Submitted Gen_Portfolio_Sumstat_Step1 Job: "${JOB_Gen_Portfolio_Sumstat_Step1_ID}
sleep 1

# Gen_Portfolio_Sumstat, Step 2
JOB_Gen_Portfolio_Sumstat_Step2_ID=`sbatch \
         --partition=${partition_Gen_Portfolio_Sumstat_Step2} --time=${time_Gen_Portfolio_Sumstat_Step2} \
         --nodes=${nodes} --ntasks=${ntasks_Gen_Portfolio_Sumstat_Step2} --job-name=Gen_Portfolio_Sumstat_Step2 \
         --depend=afterok:${JOB_Gen_Portfolio_Sumstat_Step1_ID} \
         --output="${mns_erroroutput_path}/Gen_Portfolio_Sumstat_Step2-%A_%a.out" \
         --error="${mns_erroroutput_path}/Gen_Portfolio_Sumstat_Step2-%A_%a.err" \
         --mail-user=${mailuser} --mail-type=${mailtype} --requeue --mem=${mem_Gen_Portfolio_Sumstat_Step2} \
           "${mns_code_path}/analysis/Master_Analysis_Controller.sh" Gen_Portfolio_Sumstat_Step2 | awk '{print $NF}'`
echo "Submitted Gen_Portfolio_Sumstat_Step2 Job: "${JOB_Gen_Portfolio_Sumstat_Step2_ID}
sleep 1

# Data_Comparison_Plots
JOB_Data_Comparison_Plots_ID=`sbatch \
         --partition=${partition_Data_Comparison_Plots} --time=${time_Data_Comparison_Plots} \
         --nodes=${nodes} --ntasks=${ntasks_Data_Comparison_Plots} --job-name=Data_Comparison_Plots \
         --output="${mns_erroroutput_path}/Data_Comparison_Plots-%A_%a.out" --error="${mns_erroroutput_path}/Data_Comparison_Plots-%A_%a.err" \
         --mail-user=${mailuser} --mail-type=${mailtype} --requeue --mem=${mem_Data_Comparison_Plots} \
         --depend=afterok:${JOB_Gen_HD_Sumstats_Step1_ID}:${JOB_Gen_HD_Sumstats_Step2_ID} \
           "${mns_code_path}/analysis/Master_Analysis_Controller.sh" Data_Comparison_Plots | awk '{print $NF}'`
echo "Submitted Data_Comparison_Plots Job: "${JOB_Data_Comparison_Plots_ID}
sleep 1

# CurrencyShare_TimeSeries
JOB_CurrencyShare_TimeSeries_ID=`sbatch \
         --partition=${partition_CurrencyShare_TimeSeries} --time=${time_CurrencyShare_TimeSeries} \
         --nodes=${nodes} --ntasks=${ntasks_CurrencyShare_TimeSeries} --job-name=CurrencyShare_TimeSeries \
         --output="${mns_erroroutput_path}/CurrencyShare_TimeSeries-%A_%a.out" --error="${mns_erroroutput_path}/CurrencyShare_TimeSeries-%A_%a.err" \
         --mail-user=${mailuser} --mail-type=${mailtype} --requeue --mem=${mem_CurrencyShare_TimeSeries} \
         --depend=afterok:${JOB_Gen_HD_Sumstats_Step1_ID}:${JOB_Gen_HD_Sumstats_Step2_ID} \
            "${mns_code_path}/analysis/Master_Analysis_Controller.sh" CurrencyShare_TimeSeries | awk '{print $NF}'`
echo "Submitted CurrencyShare_TimeSeries Job: "${JOB_CurrencyShare_TimeSeries_ID}
sleep 1

# CurrencyShare_BarCharts
JOB_CurrencyShare_BarCharts_ID=`sbatch \
         --partition=${partition_CurrencyShare_BarCharts} --time=${time_CurrencyShare_BarCharts} \
         --nodes=${nodes} --ntasks=${ntasks_CurrencyShare_BarCharts} --job-name=CurrencyShare_BarCharts \
         --output="${mns_erroroutput_path}/CurrencyShare_BarCharts-%A_%a.out" --error="${mns_erroroutput_path}/CurrencyShare_BarCharts-%A_%a.err" \
         --mail-user=${mailuser} --mail-type=${mailtype} --requeue --mem=${mem_CurrencyShare_BarCharts} \
         --depend=afterok:${JOB_Gen_HD_Sumstats_Step1_ID}:${JOB_Gen_HD_Sumstats_Step2_ID} \
           "${mns_code_path}/analysis/Master_Analysis_Controller.sh" CurrencyShare_BarCharts | awk '{print $NF}'`
echo "Submitted CurrencyShare_BarCharts Job: "${JOB_CurrencyShare_BarCharts_ID}
sleep 1

# Probits
JOB_Probits_ID=`sbatch \
         --partition=${partition_Probits} --time=${time_Probits} \
         --nodes=${nodes} --ntasks=${ntasks_Probits} --job-name=Probits \
         --output="${mns_erroroutput_path}/Probits-%A_%a.out" --error="${mns_erroroutput_path}/Probits-%A_%a.err" \
         --mail-user=${mailuser} --mail-type=${mailtype} --requeue --mem=${mem_Probits} \
         --depend=afterok:${JOB_Gen_HD_Sumstats_Step1_ID}:${JOB_Gen_HD_Sumstats_Step2_ID} \
           "${mns_code_path}/analysis/Master_Analysis_Controller.sh" Probits | awk '{print $NF}'`
echo "Submitted Probits Job: "${JOB_Probits_ID}
sleep 1

# Portfolio_Conc_and_Dist
JOB_Portfolio_Conc_and_Dist_ID=`sbatch \
         --partition=${partition_Portfolio_Conc_and_Dist} --time=${time_Portfolio_Conc_and_Dist} \
         --nodes=${nodes} --ntasks=${ntasks_Portfolio_Conc_and_Dist} --job-name=Portfolio_Conc_and_Dist \
         --output="${mns_erroroutput_path}/Portfolio_Conc_and_Dist-%A_%a.out" --error="${mns_erroroutput_path}/Portfolio_Conc_and_Dist-%A_%a.err" \
         --mail-user=${mailuser} --mail-type=${mailtype} --requeue --mem=${mem_Portfolio_Conc_and_Dist} \
         --depend=afterok:${JOB_Gen_HD_Sumstats_Step1_ID}:${JOB_Gen_HD_Sumstats_Step2_ID}:${JOB_Gen_Portfolio_Sumstat_Step2_ID}:${JOB_Probits_ID} \
           "${mns_code_path}/analysis/Master_Analysis_Controller.sh" Portfolio_Conc_and_Dist | awk '{print $NF}'`
echo "Submitted Portfolio_Conc_and_Dist Job: "${JOB_Portfolio_Conc_and_Dist_ID}
sleep 1

# Regressions
array_Regressions="1-13"
JOB_Regressions_ID=`sbatch \
         --partition=${partition_Regressions} --time=${time_Regressions} \
         --nodes=${nodes} --ntasks=${ntasks_Regressions} --job-name=Regressions \
         --array=${array_Regressions} --output="${mns_erroroutput_path}/Regressions-%A_%a.out" --error="${mns_erroroutput_path}/Regressions-%A_%a.err" \
         --mail-user=${mailuser} --mail-type=${mailtype} --requeue --mem=${mem_Regressions} \
         --depend=afterok:${JOB_Portfolio_Conc_and_Dist_ID} \
           "${mns_code_path}/analysis/Master_Analysis_Controller.sh" Regressions | awk '{print $NF}'`
echo "Submitted Regressions Job: "${JOB_Regressions_ID}
sleep 1

# Debt_Equity_Plots
JOB_Firm_Currency_Additional_ID=`sbatch \
         --partition=${partition_Debt_Equity_Plots} --time=${time_Debt_Equity_Plots} \
         --nodes=${nodes} --ntasks=${ntasks_Debt_Equity_Plots} --job-name=Debt_Equity_Plots \
         --output="${mns_erroroutput_path}/Debt_Equity_Plots-%A_%a.out" --error="${mns_erroroutput_path}/Debt_Equity_Plots-%A_%a.err" \
         --mail-user=${mailuser} --mail-type=${mailtype} --requeue --mem=${mem_Debt_Equity_Plots} \
         --depend=afterok:${JOB_Job_Portfolio_Conc_and_Dist_ID} \
           "${mns_code_path}/analysis/Master_Analysis_Controller.sh" Debt_Equity_Plots | awk '{print $NF}'`
echo "Submitted Debt_Equity_Plots Job: "${JOB_Debt_Equity_Plots_ID}
sleep 1

# FINISH
echo "Finished Submitting Master_Analysis."
exit

